#!/usr/bin/python3

""""
Custom dynamic inventory script for Ansible
based on yaml cache file generated by aws_ec2 plugin.
"""

import os
import json
import yaml
import argparse
from typing import Any

AWS_INVENTORY_FOLDER: str = 'aws_inventory'
ANSIBLE_USER: str = 'ubuntu'
inventory = dict()
empty_inventory: dict = {'_meta': {'hostvars': {}}}


def read_cli_args() -> Any:
    """
    Read the command line args passed to the script.
    :return: class
    """
    parser = argparse.ArgumentParser()
    parser.add_argument('--list', action='store_true')
    parser.add_argument('--host', action='store_true')
    return parser.parse_args()


def get_inventory() -> dict:
    """
    Create new data dict compatible with ansible
    :return: dict
    """
    inventory_pack = {
        'all': {
            'hosts': [],
            'vars': {}
        },
        '_meta': {
            'hostvars': {}
        }
    }
    # Возьмем последний cache file aws_ec2 inventory plugin
    raw_inventory_file = max([AWS_INVENTORY_FOLDER + '/' + file
                             for file in os.listdir(AWS_INVENTORY_FOLDER)],
                             key=os.path.getctime)
    with open(raw_inventory_file, 'r') as yaml_file:
        inventory_data = yaml.safe_load(yaml_file).get('aws_ec2')
    # Соберем новый словарь, совместимый с ansible inventory
    for ec2_data in inventory_data:
        inventory_pack['all']['hosts'].append(ec2_data.get('PublicDnsName'))
        inventory_pack['all']['vars']['ansible_ssh_user'] = ANSIBLE_USER
        inventory_pack['_meta']['hostvars'] = {}
        host_name: str = ec2_data.get('PublicDnsName')
        inventory_pack['_meta']['hostvars'][host_name] = {}
        inventory_pack['_meta']['hostvars'][host_name]['host_id'] = str(ec2_data.get('AmiLaunchIndex'))
    return inventory_pack


args = read_cli_args()

# Called with `--list`.
if args.list:
    inventory = get_inventory()
# Called with `--host [hostname]`.
elif args.host:  # Not implemented, since we return _meta info `--list`.
    inventory = empty_inventory
# If no groups or vars are present, return an empty inventory.
else:
    inventory = empty_inventory

print(json.dumps(inventory))
